package windowviewwrapper;

import main.java.com.jmedeisis.windowview.WindowView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import android.hardware.Sensor;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Build;

import main.java.com.jmedeisis.windowview.sensor.TiltSensor;


@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("WindowView")
public class windowViewWrapper extends ViewWrapper<WindowView> implements DesignerCustomView  {


	private BA ba;
	private String eventName;
        private WindowView cv;
        public String Orientation_Relative = "RELATIVE";
        public String Orientation_Absolute = "ABSOLUTE";
        public String TranslateMode_Constant = "CONSTANT";
        public String TranslateMode_Proportional = "PROPORTIONAL";
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new WindowView(ba.context);
                this.setObject(cv);
                addListener();
 	}


    @Hide
    public void addListener(){
        cv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cv.resetOrientationOrigin(false);
            }
        });
    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    public void setDrawableName(String draw) {

		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
		 Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
                 cv.setImageDrawable(drawable); 

//                 cv.setOnItemClickedListener(new SateliteClickedListener() {
			
//			public void eventOccured(int id) {

//                                if (ba.subExists(eventName + "_satelite_clicked")) {
//                                    ba.raiseEvent2(ba, false, eventName + "_satelite_clicked", true, new Object[]{id});
//                                }


//			}
//	     });
    }



    /** Maximum angle (in degrees) from origin for vertical tilts. */
    public void setMaxPitch(float maxPitch) {
        cv.setMaxPitch(maxPitch);
        cv.invalidate();
    }

    public float getMaxPitch() {
        return cv.getMaxPitch();
    }

    /** Maximum angle (in degrees) from origin for horizontal tilts. */
    public void setMaxRoll(float maxRoll) {
        cv.setMaxRoll(maxRoll);
        cv.invalidate();
    }

    public float getMaxRoll() {
        return cv.getMaxRoll();
    }

    /**
     * Horizontal origin (in degrees). When {@link #latestRoll} equals this value, the image
     * is centered horizontally.
     */
    public void setHorizontalOrigin(float horizontalOrigin) {
        cv.setHorizontalOrigin(horizontalOrigin);
        cv.invalidate();
    }

    public float getHorizontalOrigin() {
        return cv.getHorizontalOrigin();
    }

    /**
     * Vertical origin (in degrees). When {@link #latestPitch} equals this value, the image
     * is centered vertically.
     */
    public void setVerticalOrigin(float verticalOrigin) {
        cv.setVerticalOrigin(verticalOrigin);
        cv.invalidate();
    }

    public float getVerticalOrigin() {
        return cv.getVerticalOrigin();
    }

    /**
     * @param samplingPeriodUs see {@link SensorManager#registerListener(SensorEventListener, Sensor, int)}
     */
    public void setSensorSamplingPeriod(int samplingPeriodUs){
        cv.setSensorSamplingPeriod(samplingPeriodUs);
        cv.invalidate();
    }

    /** @return sensor sampling period (in microseconds). */
    public int getSensorSamplingPeriod(){
        return cv.getSensorSamplingPeriod();
    }




    /**
     * Manually resets the orientation origin. Has no effect unless {@link #getOrientationMode()}
     * is {@link OrientationMode#RELATIVE}.
     *
     * @param immediate if false, the sensor values smoothly interpolate to the new origin.
     */
    public void resetOrientationOrigin(boolean immediate){
        cv.resetOrientationOrigin(immediate);
        cv.invalidate();
    }

    /** Determines the basis in which device orientation is measured. */
    @Hide
    public enum OrientationMode {
        /** Measures absolute yaw / pitch / roll (i.e. relative to the world). */
        ABSOLUTE,
        /**
         * Measures yaw / pitch / roll relative to the starting orientation.
         * The starting orientation is determined upon receiving the first sensor data,
         * but can be manually reset at any time using {@link #resetOrientationOrigin(boolean)}.
         */
        RELATIVE
    }


    /**
     *Determines the mapping of orientation to image offset.
     *orientation_mode  -  Absolute  or  Relative  (default). 
     *Specifies whether device tilt should be tracked with respect 
     *to  Absolute  world coordinates (i.e. pitch, roll w.r.t. ground plane) 
     *or with respect to the device orientation when  WindowView  is 
     *created, which  WindowView  refers to as the 'orientation origin'. 
     *If using the latter, i.e.  Relative , you may use  resetOrientationOrigin(boolean)  
     *to set the orientation origin to that of the device when the method is called.
     */
    public void setOrientationMode(String orientationMode){
        if (orientationMode == "RELATIVE") cv.setOrientationMode(WindowView.OrientationMode.RELATIVE);
        if (orientationMode == "ABSOLUTE") cv.setOrientationMode(WindowView.OrientationMode.ABSOLUTE);
    }



    /** Determines the relationship between change in device tilt and change in image translation. */
    @Hide
    public enum TranslateMode {
        /**
         * The image is translated by a constant amount per unit of device tilt.
         * Generally preferable when viewing multiple adjacent WindowViews that have different
         * contents but should move in tandem.
         * <p>
         * Same amount of tilt will result in the same translation for two images of differing size.
         */
        CONSTANT,
        /**
         * The image is translated proportional to its off-view size. Generally preferable when
         * viewing a single WindowView, this mode ensures that the full image can be 'explored'
         * within a fixed tilt amount range.
         * <p>
         * Same amount of tilt will result in different translation for two images of differing size.
         */
        PROPORTIONAL
    }

    /** 
     *translate_mode  -  Constant  or  Proportional  (default).
     *Specifies how much the image is translated in response to device tilt.
     *If  Proportional , the image moves within the full range defined 
     *by  max_pitch  /  max_roll , with the extremities of the image visible 
     *when device pitch / roll is at those angles. If  Constant , the image moves 
     *a constant amount per unit of tilt which is defined by  max_constant_translation, 
     *achieved when pitch / roll are at  max_pitch  /  max_roll.
     */
    public void setTranslateMode(String translateMode){
        if (translateMode == "CONSTANT") cv.setTranslateMode(WindowView.TranslateMode.CONSTANT);
        if (translateMode == "PROPORTIONAL") cv.setTranslateMode(WindowView.TranslateMode.PROPORTIONAL);
    }


    /** 
     *translate_mode  -  Constant  or  Proportional  (default).
     *Specifies how much the image is translated in response to device tilt.
     *If  Proportional , the image moves within the full range defined 
     *by  max_pitch  /  max_roll , with the extremities of the image visible 
     *when device pitch / roll is at those angles. If  Constant , the image moves 
     *a constant amount per unit of tilt which is defined by  max_constant_translation, 
     *achieved when pitch / roll are at  max_pitch  /  max_roll.
     */
    public void setMaxConstantTranslation(float maxConstantTranslation){
        cv.setMaxConstantTranslation(maxConstantTranslation);
    }



}
